// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/SceneItemComponent.hpp"
#include "Card.hpp"

/** The default blind cost for the big blind. */
#define POKER_BLIND_BIG_DEFAULT 600
/** The default blind cost for the small blind. (Defaults half big blind) */
#define POKER_BLIND_SMALL_DEFAULT (POKER_BLIND_BIG_DEFAULT/2)

namespace Dawn {
  class PokerPlayer {
    public:
      int32_t i;
  };

  class PokerPot {
    public:
      int32_t i;
  };

  class PokerGame {
    protected:
      std::vector<PokerPlayer> players;
      std::vector<struct Card> cards;
      std::vector<struct Card> grave;
      std::vector<struct Card> community;
      uint8_t dealerIndex;
      uint8_t smallBlindIndex;
      uint8_t bigBlindIndex;
      uint8_t betterIndex;
      int32_t smallBlind = POKER_BLIND_SMALL_DEFAULT;
      int32_t bigBlind = POKER_BLIND_BIG_DEFAULT;

    public:
      PokerGame();
  };
}